import * as React from 'react';
import { mount } from 'cypress/react';
import Context from 'rsg-components/Context';
import slots from 'rsg-components/slots';
import ReactComponent from './ReactComponent';
import Fixture from './Fixture';
var Provider = function Provider(_ref) {
  var children = _ref.children,
    _ref$jssThemedEditor = _ref.jssThemedEditor,
    jssThemedEditor = _ref$jssThemedEditor === void 0 ? true : _ref$jssThemedEditor,
    _ref$jsxInExamples = _ref.jsxInExamples,
    jsxInExamples = _ref$jsxInExamples === void 0 ? false : _ref$jsxInExamples;
  var config = {
    usageMode: 'expand',
    exampleMode: 'expand',
    jssThemedEditor: jssThemedEditor,
    jsxInExamples: jsxInExamples,
    pagePerSection: true
  };
  return /*#__PURE__*/React.createElement(Context.Provider, {
    value: {
      slots: slots(config),
      config: config
    }
  }, children);
};
describe('ReactComponent', {
  viewportHeight: 680
}, function () {
  it('renders a Vue Component with props/slots/methods/exposed', function () {
    mount( /*#__PURE__*/React.createElement("div", {
      style: {
        padding: '24px'
      }
    }, /*#__PURE__*/React.createElement(Provider, null, /*#__PURE__*/React.createElement(ReactComponent, {
      depth: 1,
      usageMode: "expand",
      exampleMode: "expand",
      component: Fixture
    }))));
  });
});