import "core-js/modules/es.function.name.js";
import "core-js/modules/es.array.join.js";
import "core-js/modules/es.array.map.js";
import "core-js/modules/es.array.concat.js";
export default function renderTypeString(type) {
  if (!type) {
    return 'unknown';
  }
  var name = type.name,
    elements = type.elements;
  switch (name) {
    case 'Array':
      return elements ? "".concat(renderTypeString(elements[0]), "[]") : name;
    case 'union':
      return (elements || []).map(renderTypeString).join(' | ');
    case 'intersection':
      return (elements || []).map(renderTypeString).join(' & ');
    case 'undefined':
      return '-';
    default:
      return "".concat(name).concat(elements ? "<".concat(elements.map(renderTypeString).join(', '), ">") : '');
  }
}