"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _findOrigins = _interopRequireDefault(require("./findOrigins"));
// eslint-disable-next-line no-unused-vars

describe('findOrigins', function () {
  it('findOrigins() should return all filePaths in extends and mixins', function () {
    var result = (0, _findOrigins["default"])({
      props: [{
        name: 'a',
        "extends": {
          path: 'path/to/extends/prop'
        }
      }, {
        name: 'b',
        "extends": {
          path: 'path/to/extends'
        }
      }, {
        name: 'c',
        mixin: {
          path: 'path/to/mixin'
        }
      }],
      methods: [{
        name: 'm1',
        "extends": {
          path: 'path/to/extends/method'
        }
      }, {
        name: 'm2',
        "extends": {
          path: 'path/to/extends'
        }
      }, {
        name: 'm3',
        mixin: {
          path: 'path/to/mixin'
        }
      }]
    });
    expect(result).toMatchInlineSnapshot("\n\t\t\t[\n\t\t\t  \"path/to/extends/prop\",\n\t\t\t  \"path/to/extends\",\n\t\t\t  \"path/to/mixin\",\n\t\t\t  \"path/to/extends/method\",\n\t\t\t]\n\t\t");
  });
});